package mdd.client;


import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Group;
import javafx.scene.control.ComboBox;
import javafx.scene.control.TextField;
import javafx.scene.input.KeyCode;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

public class Configuration extends Group {
    private String _name = "";
    private JSONObject jparent_id = new JSONObject();
    private String _type = "";
    protected GUIEventHandler _eventHandler;

    Configuration(Module parent, String key, JSONObject json){
        jparent_id = parent.getJSONIdentifier();
        _name = key;
        setUp(json);
    }

    Configuration(JSONObject parent_id, String key, JSONObject json){
        jparent_id = parent_id;
        _name = key;
        setUp(json);
    }


    private void setUp(JSONObject json){
        _eventHandler = GUIEventHandler.getEventHandler();

        if (json.containsKey("options")){
            _type = "selection";
            ObservableList<String> options = FXCollections.observableArrayList();
            System.out.println(json.toString());
            for (Object opt : (JSONArray) json.get("options")){
                String item = opt.toString();
                options.add(opt.toString());

            }
            ComboBox cbox = new ComboBox(options);
            cbox.getSelectionModel().select(json.get("value").toString());
            cbox.setOnAction(e->{
                JSONObject jconfi = new JSONObject();
                jconfi.put("value", cbox.getValue().toString());
                JSONObject jconfigs = new JSONObject();
                jconfigs.put(_name, jconfi);
                JSONObject jconfigure = new JSONObject();
                jconfigure.put("configure", jconfigs);
                JSONObject jmsg = new JSONObject();
                jmsg.put("operation", "change");
                JSONObject jargs = new JSONObject();
                jargs.put("subject",  jparent_id);
                jargs.put("object",   jconfigure);
                jmsg.put("args", jargs);
                _eventHandler.publishEvent("try", jmsg);
            });
            getChildren().addAll(cbox);
        }
        else {
            _type = "input";
            TextField cfield = new TextField(json.get("value").toString());
            cfield.setOnKeyPressed(event -> {
                if (event.getCode().equals(KeyCode.ENTER)) {
                    JSONObject jconfi = new JSONObject();
                    jconfi.put("value", cfield.getText().toString());
                    JSONObject jconfigs = new JSONObject();
                    jconfigs.put(_name, jconfi);
                    JSONObject jconfigure = new JSONObject();
                    jconfigure.put("configure", jconfigs);
                    JSONObject jmsg = new JSONObject();
                    jmsg.put("operation", "change");
                    JSONObject jargs = new JSONObject();
                    jargs.put("subject", jparent_id);
                    jargs.put("object", jconfigure);
                    jmsg.put("args", jargs);
                    _eventHandler.publishEvent("try", jmsg);
                }
            });
            getChildren().addAll(cfield);
        }
    }

    public String getName(){
        return _name;
    }
}
